Index: CKEditor/branches/versions/3.5.x/_source/plugins/find/dialogs/find.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/find/dialogs/find.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/find/dialogs/find.js	(revision 6050)
@@ -72,5 +72,5 @@
 		// 1. Defined as full match style to avoid compromising ordinary text color styles.
 		// 2. Must be apply onto inner-most text to avoid conflicting with ordinary text color styles visually.
-		var highlightStyle = new CKEDITOR.style( CKEDITOR.tools.extend( { fullMatch : true, childRule : function(){ return false; } },
+		var highlightStyle = new CKEDITOR.style( CKEDITOR.tools.extend( { fullMatch : true, childRule : function(){ return 0; } },
 			editor.config.find_highlight ) );
 
@@ -84,9 +84,19 @@
 		var characterWalker = function( range , matchWord )
 		{
+			var self = this;
 			var walker =
 				new CKEDITOR.dom.walker( range );
-			walker.guard = matchWord ? nonCharactersBoundary : null;
+			walker.guard = matchWord ? nonCharactersBoundary : function( node )
+			{
+				!nonCharactersBoundary( node ) && ( self._.matchBoundary = true );
+			};
 			walker[ 'evaluator' ] = findEvaluator;
-			walker.breakOnFalse = true;
+			walker.breakOnFalse = 1;
+
+			if ( range.startContainer.type == CKEDITOR.NODE_TEXT )
+			{
+				this.textNode = range.startContainer;
+				this.offset = range.startOffset - 1;
+			}
 
 			this._ = {
@@ -112,5 +122,5 @@
 				var currentTextNode = this.textNode;
 				// Already at the end of document, no more character available.
-				if (  currentTextNode === null )
+				if ( currentTextNode === null )
 					return cursorStep.call( this );
 
@@ -143,12 +153,6 @@
 						// already reach document end.
 						if ( this._.matchWord && !currentTextNode
-							 ||this._.walker._.end )
+							 || this._.walker._.end )
 							break;
-
-						// Marking as match character boundaries.
-						if ( !currentTextNode
-						   && !nonCharactersBoundary( this._.walker.current ) )
-							this._.matchBoundary = true;
-
 					}
 					// Found a fresh text node.
@@ -176,5 +180,5 @@
 				rangeLength : rangeLength,
 				highlightRange : null,
-				isMatched : false
+				isMatched : 0
 			};
 		};
@@ -512,5 +516,5 @@
 				if ( matchCyclic && !cyclicRerun )
 				{
-					this.searchRange = getSearchRange( true );
+					this.searchRange = getSearchRange( 1 );
 					this.matchRange = null;
 					return arguments.callee.apply( this,
@@ -532,5 +536,5 @@
 
 				// Successiveness of current replace/find.
-				var result = false;
+				var result = 0;
 
 				// 1. Perform the replace when there's already a match here.
@@ -562,5 +566,5 @@
 					this.matchRange._.isReplaced = true;
 					this.replaceCounter++;
-					result = true;
+					result = 1;
 				}
 				else
@@ -596,15 +600,16 @@
 		}
 
+		var lang = editor.lang.findAndReplace;
 		return {
-			title : editor.lang.findAndReplace.title,
+			title : lang.title,
 			resizable : CKEDITOR.DIALOG_RESIZE_NONE,
 			minWidth : 350,
 			minHeight : 165,
-			buttons : [ CKEDITOR.dialog.cancelButton ],		//Cancel button only.
+			buttons : [ CKEDITOR.dialog.cancelButton ],		// Cancel button only.
 			contents : [
 				{
 					id : 'find',
-					label : editor.lang.findAndReplace.find,
-					title : editor.lang.findAndReplace.find,
+					label : lang.find,
+					title : lang.find,
 					accessKey : '',
 					elements : [
@@ -617,5 +622,5 @@
 									type : 'text',
 									id : 'txtFindFind',
-									label : editor.lang.findAndReplace.findWhat,
+									label : lang.findWhat,
 									isChanged : false,
 									labelLayout : 'horizontal',
@@ -626,5 +631,5 @@
 									align : 'left',
 									style : 'width:100%',
-									label : editor.lang.findAndReplace.find,
+									label : lang.find,
 									onClick : function()
 									{
@@ -634,5 +639,5 @@
 													dialog.getValueOf( 'find', 'txtFindWordChk' ),
 													dialog.getValueOf( 'find', 'txtFindCyclic' ) ) )
-											alert( editor.lang.findAndReplace
+											alert( lang
 												.notFoundMsg );
 									}
@@ -650,5 +655,5 @@
 									isChanged : false,
 									style : 'margin-top:28px',
-									label : editor.lang.findAndReplace.matchCase
+									label : lang.matchCase
 								},
 								{
@@ -656,5 +661,5 @@
 									id : 'txtFindWordChk',
 									isChanged : false,
-									label : editor.lang.findAndReplace.matchWord
+									label : lang.matchWord
 								},
 								{
@@ -663,5 +668,5 @@
 									isChanged : false,
 									'default' : true,
-									label : editor.lang.findAndReplace.matchCyclic
+									label : lang.matchCyclic
 								}
 							]
@@ -671,5 +676,5 @@
 				{
 					id : 'replace',
-					label : editor.lang.findAndReplace.replace,
+					label : lang.replace,
 					accessKey : 'M',
 					elements : [
@@ -682,5 +687,5 @@
 									type : 'text',
 									id : 'txtFindReplace',
-									label : editor.lang.findAndReplace.findWhat,
+									label : lang.findWhat,
 									isChanged : false,
 									labelLayout : 'horizontal',
@@ -691,5 +696,5 @@
 									align : 'left',
 									style : 'width:100%',
-									label : editor.lang.findAndReplace.replace,
+									label : lang.replace,
 									onClick : function()
 									{
@@ -701,5 +706,5 @@
 													dialog.getValueOf( 'replace', 'txtReplaceWordChk' ),
 													dialog.getValueOf( 'replace', 'txtReplaceCyclic' ) ) )
-											alert( editor.lang.findAndReplace
+											alert( lang
 												.notFoundMsg );
 									}
@@ -715,5 +720,5 @@
 									type : 'text',
 									id : 'txtReplace',
-									label : editor.lang.findAndReplace.replaceWith,
+									label : lang.replaceWith,
 									isChanged : false,
 									labelLayout : 'horizontal',
@@ -724,5 +729,5 @@
 									align : 'left',
 									style : 'width:100%',
-									label : editor.lang.findAndReplace.replaceAll,
+									label : lang.replaceAll,
 									isChanged : false,
 									onClick : function()
@@ -734,5 +739,5 @@
 
 										// Scope to full document.
-										finder.searchRange = getSearchRange( true );
+										finder.searchRange = getSearchRange( 1 );
 										if ( finder.matchRange )
 										{
@@ -751,9 +756,9 @@
 										if ( finder.replaceCounter )
 										{
-											alert( editor.lang.findAndReplace.replaceSuccessMsg.replace( /%1/, finder.replaceCounter ) );
+											alert( lang.replaceSuccessMsg.replace( /%1/, finder.replaceCounter ) );
 											editor.fire( 'saveSnapshot' );
 										}
 										else
-											alert( editor.lang.findAndReplace.notFoundMsg );
+											alert( lang.notFoundMsg );
 									}
 								}
@@ -769,5 +774,5 @@
 									id : 'txtReplaceCaseChk',
 									isChanged : false,
-									label : editor.lang.findAndReplace
+									label : lang
 										.matchCase
 								},
@@ -776,5 +781,5 @@
 									id : 'txtReplaceWordChk',
 									isChanged : false,
-									label : editor.lang.findAndReplace
+									label : lang
 										.matchWord
 								},
@@ -784,5 +789,5 @@
 									isChanged : false,
 									'default' : true,
-									label : editor.lang.findAndReplace
+									label : lang
 										.matchCyclic
 								}
@@ -796,17 +801,17 @@
 				var dialog = this;
 
-				//keep track of the current pattern field in use.
+				// Keep track of the current pattern field in use.
 				var patternField, wholeWordChkField;
 
-				//Ignore initial page select on dialog show
-				var isUserSelect = false;
-				this.on('hide', function()
-						{
-							isUserSelect = false;
-						} );
-				this.on('show', function()
-						{
-							isUserSelect = true;
-						} );
+				// Ignore initial page select on dialog show
+				var isUserSelect = 0;
+				this.on( 'hide', function()
+						{
+							isUserSelect = 0;
+						});
+				this.on( 'show', function()
+						{
+							isUserSelect = 1;
+						});
 
 				this.selectPage = CKEDITOR.tools.override( this.selectPage, function( originalFunc )
@@ -826,5 +831,5 @@
 								wholeWordChkFieldId );
 
-							// prepare for check pattern text filed 'keyup' event
+							// Prepare for check pattern text filed 'keyup' event
 							if ( !currPage.initialized )
 							{
@@ -834,6 +839,6 @@
 							}
 
+							// Synchronize fields on tab switch.
 							if ( isUserSelect )
-								// synchronize fields on tab switch.
 								syncFieldsBetweenTabs.call( this, pageId );
 						};
Index: CKEditor/branches/versions/3.5.x/_source/plugins/flash/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/flash/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/flash/plugin.js	(revision 6050)
@@ -6,13 +6,7 @@
 (function()
 {
-	var flashFilenameRegex = /\.swf(?:$|\?)/i,
-		numberRegex = /^\d+(?:\.\d+)?$/;
+	var flashFilenameRegex = /\.swf(?:$|\?)/i;
 
-	function cssifyLength( length )
-	{
-		if ( numberRegex.test( length ) )
-			return length + 'px';
-		return length;
-	}
+	var cssifyLength = CKEDITOR.tools.cssLength;
 
 	function isFlashEmbed( element )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js	(revision 6050)
@@ -17,12 +17,6 @@
 	{
 		// Generates the panel key: docId-eleId-skinName-langDir[-uiColor][-CSSs][-level]
-		var key =
-			doc.getUniqueId() +
-			'-' + parentElement.getUniqueId() +
-			'-' + editor.skinName +
-			'-' + editor.lang.dir +
-			( ( editor.uiColor && ( '-' + editor.uiColor ) ) || '' ) +
-			( ( definition.css && ( '-' + definition.css ) ) || '' ) +
-			( ( level && ( '-' + level ) ) || '' );
+		var key = CKEDITOR.tools.genKey( doc.getUniqueId(), parentElement.getUniqueId(), editor.skinName, editor.lang.dir,
+			editor.uiColor || '', definition.css || '', level || '' );
 
 		var panel = panels[ key ];
@@ -47,5 +41,5 @@
 		$ : function( editor, parentElement, definition, level )
 		{
-			definition.forceIFrame = true;
+			definition.forceIFrame = 1;
 
 			var doc = parentElement.getDocument(),
@@ -105,5 +99,5 @@
 
 				this.allowBlur( false );
-				isShowing = true;
+				isShowing = 1;
 
 				var element = this.element,
@@ -130,5 +124,6 @@
 				element.setStyles(
 					{
-						top : '-30000px',
+						top : 0,
+						left: 0,
 						display	: ''
 					});
@@ -283,4 +278,12 @@
 							}
 
+							// Trigger the onHide event of the previously active panel to prevent
+							// incorrect styles from being applied (#6170)
+							var innerElement = element.getFirst(),
+								activePanel;
+							if ( ( activePanel = innerElement.getCustomData( 'activePanel' ) ) )
+								activePanel.onHide && activePanel.onHide.call( this, 1 );
+							innerElement.setCustomData( 'activePanel', this );
+
 							element.setStyles(
 								{
@@ -306,5 +309,5 @@
 					this.onShow.call( this );
 
-				isShowing = false;
+				isShowing = 0;
 			},
 
@@ -316,4 +319,5 @@
 					this.element.setStyle( 'display', 'none' );
 					this.visible = 0;
+					this.element.getFirst().removeCustomData( 'activePanel' );
 				}
 			},
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/button.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/button.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/button.js	(revision 6050)
@@ -13,8 +13,8 @@
 			delete this.button;
 			var element = this.getParentEditor().getSelection().getSelectedElement();
-			if ( element && element.getName() == "input" )
+			if ( element && element.is( 'input' ) )
 			{
 				var type = element.getAttribute( 'type' );
-				if ( type == "button" || type == "reset" || type == "submit" )
+				if ( type in { button:1, reset:1, submit:1 } )
 				{
 					this.button = element;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/checkbox.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/checkbox.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/checkbox.js	(revision 6050)
@@ -15,5 +15,5 @@
 			var element = this.getParentEditor().getSelection().getSelectedElement();
 
-			if ( element && element.getAttribute( 'type' ) == "checkbox" )
+			if ( element && element.getAttribute( 'type' ) == 'checkbox' )
 			{
 				this.checkbox = element;
@@ -32,8 +32,6 @@
 				element = editor.document.createElement( 'input' );
 				element.setAttribute( 'type', 'checkbox' );
+				editor.insertElement( element );
 			}
-
-			if ( isInsertMode )
-				editor.insertElement( element );
 			this.commitContent( { element : element } );
 		},
@@ -95,5 +93,5 @@
 								if ( CKEDITOR.env.ie )
 								{
-									// Remove attribute 'value' of checkbox #4721.
+									// Remove attribute 'value' of checkbox (#4721).
 									var checkbox = new CKEDITOR.dom.element( 'input', element.getDocument() );
 									element.copyAttributes( checkbox, { value: 1 } );
@@ -124,6 +122,6 @@
 							if ( CKEDITOR.env.ie )
 							{
-								var isElementChecked = !!element.getAttribute( 'checked' );
-								var isChecked = !!this.getValue();
+								var isElementChecked = !!element.getAttribute( 'checked' ),
+									isChecked = !!this.getValue();
 
 								if ( isElementChecked != isChecked )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/radio.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/radio.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/radio.js	(revision 6050)
@@ -14,5 +14,5 @@
 
 			var element = this.getParentEditor().getSelection().getSelectedElement();
-			if ( element && element.getName() == "input" && element.getAttribute( 'type' ) == "radio" )
+			if ( element && element.getName() == 'input' && element.getAttribute( 'type' ) == 'radio' )
 			{
 				this.radioButton = element;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js	(revision 6050)
@@ -194,5 +194,5 @@
 						{
 							if ( name == 'clear' )
-								this.setValue( this.default || '' );
+								this.setValue( this['default'] || '' );
 							else if ( name == 'select' )
 							{
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/plugin.js	(revision 6050)
@@ -192,8 +192,11 @@
 					switch ( type )
 					{
-						case 'text' : case 'password':
+						case 'text' :
+						case 'password' :
 							evt.data.dialog = 'textfield';
 							break;
-						case 'button' : case 'submit' : case 'reset' :
+						case 'button' :
+						case 'submit' :
+						case 'reset' :
 							evt.data.dialog = 'button';
 							break;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/htmldataprocessor/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/htmldataprocessor/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/htmldataprocessor/plugin.js	(revision 6050)
@@ -264,5 +264,6 @@
 	}
 
-	var protectAttributeRegex = /<(?:a|area|img|input)[\s\S]*?\s((?:href|src|name)\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|(?:[^ "'>]+)))/gi;
+	var protectAttributeRegex = /<((?:a|area|img|input)[\s\S]*?\s)((href|src|name)\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|(?:[^ "'>]+)))([^>]*)>/gi,
+		findSavedSrcRegex = /\s_cke_saved_src\s*=/;
 
 	var protectElementsRegex = /(?:<style(?=[ >])[^>]*>[\s\S]*<\/style>)|(?:<(:?link|meta|base)[^>]*>)/gi,
@@ -276,5 +277,12 @@
 	function protectAttributes( html )
 	{
-		return html.replace( protectAttributeRegex, '$& _cke_saved_$1' );
+		return html.replace( protectAttributeRegex, function( tag, beginning, fullAttr, attrName, end )
+			{
+				// We should not rewrite the _cke_saved_src attribute (#5218)
+				if ( attrName == 'src' && findSavedSrcRegex.test( tag ) )
+					return tag;
+				else
+					return '<' + beginning + fullAttr + ' _cke_saved_' + fullAttr + end + '>';
+			});
 	}
 
@@ -308,4 +316,9 @@
 	{
 		return html.replace( protectSelfClosingRegex, '<cke:$1$2></cke:$1>' );
+	}
+
+	function protectPreFormatted( html )
+	{
+		return html.replace( /(<pre\b[^>]*>)(\r\n|\n)/g, '$1$2$2' );
 	}
 
@@ -430,4 +443,8 @@
 			data = protectSelfClosingElements( data );
 
+			// Compensate one leading line break after <pre> open as browsers
+			// eat it up. (#5789)
+			data = protectPreFormatted( data );
+
 			// Call the browser to help us fixing a possibly invalid HTML
 			// structure.
@@ -484,3 +501,2 @@
  * config.forceSimpleAmpersand = false;
  */
-CKEDITOR.config.forceSimpleAmpersand = false;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/htmlwriter/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/htmlwriter/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/htmlwriter/plugin.js	(revision 6050)
@@ -58,10 +58,12 @@
 		this.lineBreakChars = '\n';
 
-		this.forceSimpleAmpersand = false;
-
-		this.sortAttributes = true;
-
-		this._.indent = false;
+		this.forceSimpleAmpersand = 0;
+
+		this.sortAttributes = 1;
+
+		this._.indent = 0;
 		this._.indentation = '';
+		// Indicate preformatted block context status. (#5789)
+		this._.inPre = 0;
 		this._.rules = {};
 
@@ -72,9 +74,9 @@
 			this.setRules( e,
 				{
-					indent : true,
-					breakBeforeOpen : true,
-					breakAfterOpen : true,
+					indent : 1,
+					breakBeforeOpen : 1,
+					breakAfterOpen : 1,
 					breakBeforeClose : !dtd[ e ][ '#' ],
-					breakAfterClose : true
+					breakAfterClose : 1
 				});
 		}
@@ -82,17 +84,17 @@
 		this.setRules( 'br',
 			{
-				breakAfterOpen : true
+				breakAfterOpen : 1
 			});
 
 		this.setRules( 'title',
 			{
-				indent : false,
-				breakAfterOpen : false
+				indent : 0,
+				breakAfterOpen : 0
 			});
 
 		this.setRules( 'style',
 			{
-				indent : false,
-				breakBeforeClose : true
+				indent : 0,
+				breakBeforeClose : 1
 			});
 
@@ -100,5 +102,5 @@
 		this.setRules( 'pre',
 			{
-			  indent: false
+			  indent : 0
 			});
 	},
@@ -159,4 +161,5 @@
 			if ( rules && rules.breakAfterOpen )
 				this.lineBreak();
+			tagName == 'pre' && ( this._.inPre = 1 );
 		},
 
@@ -207,4 +210,5 @@
 
 			this._.output.push( '</', tagName, '>' );
+			tagName == 'pre' && ( this._.inPre = 0 );
 
 			if ( rules && rules.breakAfterClose )
@@ -224,5 +228,5 @@
 			{
 				this.indentation();
-				text = CKEDITOR.tools.ltrim( text );
+				!this._.inPre  && ( text = CKEDITOR.tools.ltrim( text ) );
 			}
 
@@ -253,7 +257,7 @@
 		lineBreak : function()
 		{
-			if ( this._.output.length > 0 )
+			if ( !this._.inPre && this._.output.length > 0 )
 				this._.output.push( this.lineBreakChars );
-			this._.indent = true;
+			this._.indent = 1;
 		},
 
@@ -268,6 +272,7 @@
 		indentation : function()
 		{
-			this._.output.push( this._.indentation );
-			this._.indent = false;
+			if( !this._.inPre )
+				this._.output.push( this._.indentation );
+			this._.indent = 0;
 		},
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/iframedialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/iframedialog/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/iframedialog/plugin.js	(revision 6050)
@@ -75,5 +75,5 @@
 					cssWidth = CKEDITOR.tools.cssLength( elementDefinition.width ),
 					cssHeight = CKEDITOR.tools.cssLength( elementDefinition.height );
-				_.frameId = CKEDITOR.tools.getNextNumber() + '_iframe';
+				_.frameId = CKEDITOR.tools.getNextId() + '_iframe';
 
 				// IE BUG: Parent container does not resize to contain the iframe automatically.
Index: CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/image/dialogs/image.js	(revision 6050)
@@ -542,5 +542,4 @@
 													// Manually set the initial value.(#4191)
 													field.setInitValue();
-													field.focus();
 												}
 											},
@@ -1125,5 +1124,5 @@
 								action : 'Browse',
 								target: 'Link:txtUrl',
-								url: editor.config.filebrowserImageBrowseLinkUrl || editor.config.filebrowserBrowseUrl
+								url: editor.config.filebrowserImageBrowseLinkUrl
 							},
 							style : 'float:right',
Index: CKEditor/branches/versions/3.5.x/_source/plugins/indent/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/indent/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/indent/plugin.js	(revision 6050)
@@ -158,5 +158,6 @@
 				// Convert the array back to a DOM forest (yes we might have a few subtrees now).
 				// And replace the old list with the new forest.
-				var newList = CKEDITOR.plugins.list.arrayToList( listArray, database, null, editor.config.enterMode, 0 );
+				var newListDir = listNode.getAttribute( 'dir' ) || listNode.getStyle( 'direction' );
+				var newList = CKEDITOR.plugins.list.arrayToList( listArray, database, null, editor.config.enterMode, newListDir );
 
 				// Avoid nested <li> after outdent even they're visually same,
@@ -256,9 +257,10 @@
 				else
 				{
-					var indentCssProperty = getIndentCssProperty( element );
-					var currentOffset = parseInt( element.getStyle( indentCssProperty ), 10 );
+					var indentCssProperty = getIndentCssProperty( element ),
+						currentOffset = parseInt( element.getStyle( indentCssProperty ), 10 );
 					if ( isNaN( currentOffset ) )
 						currentOffset = 0;
-					currentOffset += ( self.name == 'indent' ? 1 : -1 ) * editor.config.indentOffset;
+					var indentOffset = editor.config.indentOffset || 40;
+					currentOffset += ( self.name == 'indent' ? 1 : -1 ) * indentOffset;
 
 					if ( currentOffset < 0 )
@@ -266,25 +268,24 @@
 
 					currentOffset = Math.max( currentOffset, 0 );
-					currentOffset = Math.ceil( currentOffset / editor.config.indentOffset ) * editor.config.indentOffset;
-					element.setStyle( indentCssProperty, currentOffset ? currentOffset + editor.config.indentUnit : '' );
+					currentOffset = Math.ceil( currentOffset / indentOffset ) * indentOffset;
+					element.setStyle( indentCssProperty, currentOffset ? currentOffset + ( editor.config.indentUnit || 'px' ) : '' );
 					if ( element.getAttribute( 'style' ) === '' )
 						element.removeAttribute( 'style' );
 				}
 
-				CKEDITOR.dom.element.setMarker( database, element, 'indent_processed', true );
+				CKEDITOR.dom.element.setMarker( database, element, 'indent_processed', 1 );
 				return true;
 			}
 
 			var selection = editor.getSelection(),
-				bookmarks = selection.createBookmarks( true ),
-				ranges = selection && selection.getRanges( true ),
+				bookmarks = selection.createBookmarks( 1 ),
+				ranges = selection && selection.getRanges( 1 ),
 				range;
+
 
 			var iterator = ranges.createIterator();
 			while ( ( range = iterator.getNextRange() ) )
 			{
-				var startContainer = range.startContainer,
-					endContainer = range.endContainer,
-					rangeRoot = range.getCommonAncestor(),
+				var rangeRoot = range.getCommonAncestor(),
 					nearestListBlock = rangeRoot;
 
@@ -293,8 +294,23 @@
 					nearestListBlock = nearestListBlock.getParent();
 
+				// Avoid having selection enclose the entire list. (#6138)
+				// [<ul><li>...</li></ul>] =><ul><li>[...]</li></ul>
+				if ( !nearestListBlock )
+				{
+					var selectedNode = range.getEnclosedNode();
+					if ( selectedNode
+						&& selectedNode.type == CKEDITOR.NODE_ELEMENT
+						&& selectedNode.getName() in listNodeNames)
+					{
+						range.setStartAt( selectedNode, CKEDITOR.POSITION_AFTER_START );
+						range.setEndAt( selectedNode, CKEDITOR.POSITION_BEFORE_END );
+						nearestListBlock = selectedNode;
+					}
+				}
+
 				// Avoid selection anchors under list root.
 				// <ul>[<li>...</li>]</ul> =>	<ul><li>[...]</li></ul>
-				if ( nearestListBlock && startContainer.type == CKEDITOR.NODE_ELEMENT
-					&& startContainer.getName() in listNodeNames )
+				if ( nearestListBlock && range.startContainer.type == CKEDITOR.NODE_ELEMENT
+					&& range.startContainer.getName() in listNodeNames )
 				{
 					var walker = new CKEDITOR.dom.walker( range );
@@ -303,6 +319,6 @@
 				}
 
-				if ( nearestListBlock && endContainer.type == CKEDITOR.NODE_ELEMENT
-					&& endContainer.getName() in listNodeNames )
+				if ( nearestListBlock && range.endContainer.type == CKEDITOR.NODE_ELEMENT
+					&& range.endContainer.getName() in listNodeNames )
 				{
 					walker = new CKEDITOR.dom.walker( range );
@@ -311,5 +327,5 @@
 				}
 
-				if ( nearestListBlock  )
+				if ( nearestListBlock )
 				{
 					var firstListItem = nearestListBlock.getFirst( function( node )
@@ -320,7 +336,10 @@
 						indentWholeList = firstListItem.equals( rangeStart ) || firstListItem.contains( rangeStart );
 
-					// Indent the entire list if  cursor is inside the first list item. (#3893)
-					if ( !( indentWholeList && indentElement( nearestListBlock ) ) )
-						indentList( nearestListBlock );
+					// Indent the entire list if cursor is inside the first list item. (#3893)
+					// Only do that for indenting or when using indent classes or when there is something to outdent. (#6141)
+					if ( !( indentWholeList &&
+						( self.name == 'indent' || self.useIndentClasses || parseInt( nearestListBlock.getStyle( getIndentCssProperty( nearestListBlock ) ), 10 ) ) &&
+							indentElement( nearestListBlock ) ) )
+								indentList( nearestListBlock );
 				}
 				else
@@ -372,4 +391,36 @@
 					"}" );
 			}
+
+			// Register dirChanged listener.
+			editor.on( 'dirChanged', function( e )
+			{
+				var range = new CKEDITOR.dom.range( editor.document );
+				range.setStartBefore( e.data );
+				range.setEndAfter( e.data );
+
+				var walker = new CKEDITOR.dom.walker( range ),
+					node;
+
+				while ( ( node = walker.next() ) )
+				{
+					if ( node.type == CKEDITOR.NODE_ELEMENT )
+					{
+						// A child with the defined dir is to be ignored.
+						if ( !node.equals( e.data ) && node.getDirection() )
+						{
+							range.setStartAfter( node );
+							walker = new CKEDITOR.dom.walker( range );
+							continue;
+						}
+
+						// Switch the margins.
+						var marginLeft = node.getStyle( 'margin-right' ),
+							marginRight = node.getStyle( 'margin-left' );
+
+						marginLeft ? node.setStyle( 'margin-left', marginLeft ) : node.removeStyle( 'margin-left' );
+						marginRight ? node.setStyle( 'margin-right', marginRight ) : node.removeStyle( 'margin-right' );
+					}
+				}
+			});
 		},
 
@@ -377,36 +428,4 @@
 	} );
 })();
-
-CKEDITOR.tools.extend( CKEDITOR.config,
-	{
-		indentOffset : 40,
-		indentUnit : 'px',
-		indentClasses : null
-	});
-
-/**
- * Size of each indentation step
- * @type Number
- * @example
- * config.indentOffset = 40;
- */
-
- /**
- * Unit for the indentation style
- * @type String
- * @example
- * config.indentUnit = 'px';
- */
-
- /**
- * List of classes to use for indenting the contents.
- * @type Array
- * @example
- * // Don't use classes for indenting. (this is the default value)
- * config.indentClasses = null;
- * @example
- * // Use the classes 'Indent1', 'Indent2', 'Indent3'
- * config.indentClasses = ['Indent1', 'Indent2', 'Indent3'];
- */
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/justify/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/justify/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/justify/plugin.js	(revision 6050)
@@ -26,7 +26,18 @@
 		useComputedState = useComputedState === undefined || useComputedState;
 
-		var align = useComputedState ?
-			element.getComputedStyle( 'text-align' ) :
-			element.getStyle( 'text-align' ) || element.getAttribute( 'align' ) || '';
+		var align;
+		if ( useComputedState )
+			align = element.getComputedStyle( 'text-align' );
+		else
+		{
+			while ( !element.hasAttribute || !( element.hasAttribute( 'align' ) || element.getStyle( 'text-align' ) ) )
+			{
+				var parent = element.getParent();
+				if ( !parent )
+					break;
+				element = parent;
+			}
+			align = element.getStyle( 'text-align' ) || element.getAttribute( 'align' ) || '';
+		}
 
 		align && ( align = align.replace( /-moz-|-webkit-|start|auto/i, '' ) );
@@ -69,4 +80,39 @@
 
 			this.cssClassRegex = new RegExp( '(?:^|\\s+)(?:' + classes.join( '|' ) + ')(?=$|\\s)' );
+		}
+	}
+
+	function onDirChanged( e )
+	{
+		var editor = e.editor;
+
+		var range = new CKEDITOR.dom.range( editor.document );
+		range.setStartBefore( e.data );
+		range.setEndAfter( e.data );
+
+		var walker = new CKEDITOR.dom.walker( range ),
+			node;
+
+		while ( ( node = walker.next() ) )
+		{
+			if ( node.type == CKEDITOR.NODE_ELEMENT )
+			{
+				// A child with the defined dir is to be ignored.
+				if ( !node.equals( e.data ) && node.getDirection() )
+				{
+					range.setStartAfter( node );
+					walker = new CKEDITOR.dom.walker( range );
+					continue;
+				}
+
+				// Switch the alignment.
+				var style = 'text-align';
+				var align = node.getStyle( style );
+
+				if ( align == 'left' )
+					node.setStyle( style, 'right' );
+				else if ( align == 'right' )
+					node.setStyle( style, 'left' );
+			}
 		}
 	}
@@ -168,4 +214,5 @@
 			editor.on( 'selectionChange', CKEDITOR.tools.bind( onSelectionChange, center ) );
 			editor.on( 'selectionChange', CKEDITOR.tools.bind( onSelectionChange, justify ) );
+			editor.on( 'dirChanged', onDirChanged );
 		},
 
@@ -173,7 +220,2 @@
 	});
 })();
-
-CKEDITOR.tools.extend( CKEDITOR.config,
-	{
-		justifyClasses : null
-	} );
Index: CKEditor/branches/versions/3.5.x/_source/plugins/keystrokes/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/keystrokes/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/keystrokes/plugin.js	(revision 6050)
@@ -29,12 +29,8 @@
 
 		for ( var i = 0 ; i < keystrokesConfig.length ; i++ )
-		{
 			keystrokes[ keystrokesConfig[i][0] ] = keystrokesConfig[i][1];
-		}
 
 		for ( i = 0 ; i < blockedConfig.length ; i++ )
-		{
 			blockedKeystrokes[ blockedConfig[i] ] = 1;
-		}
 	}
 });
